From 8704e3ed14eada73216eb55ac226011e48479556 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 02 2020 05:33:25 +0000
Subject: [PATCH 1213/2232] Preserve source order of namespaces for forward declaration


This enables us to avoid answering hard questions like whether 'foo10'
is less or greater than 'foo9'.

---

diff --git a/gen/src/alphasort.rs b/gen/src/alphasort.rs
index 18f2896..748ec3f 100644
--- a/gen/src/alphasort.rs
+++ b/gen/src/alphasort.rs
@@ -1,11 +1,11 @@
 use crate::syntax::Api;
 use proc_macro2::Ident;
-use std::collections::BTreeMap;
+use std::collections::HashMap as Map;
 use std::iter::FromIterator;
 
 pub struct NamespaceEntries<'a> {
     direct: Vec<&'a Api>,
-    nested: BTreeMap<&'a Ident, NamespaceEntries<'a>>,
+    nested: Vec<(&'a Ident, NamespaceEntries<'a>)>,
 }
 
 impl<'a> NamespaceEntries<'a> {
@@ -25,13 +25,18 @@ impl<'a> NamespaceEntries<'a> {
 
 fn sort_by_inner_namespace(apis: Vec<&Api>, depth: usize) -> NamespaceEntries {
     let mut direct = Vec::new();
-    let mut nested_namespaces = BTreeMap::new();
+    let mut nested_namespaces = Vec::new();
+    let mut index_of_namespace = Map::new();
+
     for api in &apis {
         if let Some(first_ns_elem) = api.namespace().and_then(|ns| ns.iter().nth(depth)) {
-            nested_namespaces
-                .entry(first_ns_elem)
-                .or_insert_with(Vec::new)
-                .push(*api);
+            match index_of_namespace.get(first_ns_elem) {
+                None => {
+                    index_of_namespace.insert(first_ns_elem, nested_namespaces.len());
+                    nested_namespaces.push((first_ns_elem, vec![*api]));
+                }
+                Some(&index) => nested_namespaces[index].1.push(*api),
+            }
             continue;
         }
         direct.push(*api);

